Subsections

- - - - Command overview
- Common options to darcs commands
  - Selecting patches
  - Match
  - Resolution of conflicts
- Options apart from darcs commands
- Creating repositories
  - darcs initialize
  - darcs get
  - darcs put
- Modifying the contents of a repo
  - darcs add
  - darcs remove
  - darcs mv
  - darcs replace
- Working with changes
  - darcs record
  - darcs pull
  - darcs push
  - darcs send
  - darcs apply
- Seeing what you've done
  - darcs whatsnew
  - darcs changes
  - darcs query manifest
- More advanced commands
  - darcs tag
  - darcs setpref
  - darcs check
  - darcs optimize
- Undoing, redoing and running in circles
  - darcs amend-record
  - darcs rollback
  - darcs unrecord
  - darcs unpull
  - darcs obliterate
  - darcs revert
  - darcs unrevert
- Advanced examination of the repository
  - darcs diff
  - darcs annotate
  - darcs query manifest
- Rarely needed and obscure commands
  - darcs resolve
  - darcs dist
  - darcs trackdown
    - Example usage
  - darcs repair

# Darcs commands

The general format of a darcs command is

    % darcs COMMAND OPTIONS ARGUMENTS ...

Here `COMMAND` is a command such as `add` or `record`, which of course may have one or more arguments. Options have the form `--option` or `-o`, while arguments vary from command to command. There are many options which are common to a number of different commands, which will be summarized here.

If you wish, you may use any unambiguous beginning of a command name as a shortcut: for `darcs record`, you could type `darcs recor` or `darcs rec`, but not `darcs re` since that could be confused with `darcs replace`, `darcs revert` and `darcs remove`.

In some cases, `COMMAND` actually consists of two words, a super-command and a subcommand. For example, the ``display the manifest'' command has the form `darcs query manifest`.

#### Command overview

Not all commands modify the ``patches'' of your repository (that is, the named patches which other users can pull), some commands only affect the copy of the source tree you're working on (your ``working directory''), and some affect both. This table summarizes what you should expect from each one and will hopefully serve as guide when you're having doubts about which command to use.

affects | patches | working directory
record | yes | no
unrecord | yes | no
rollback | yes | no
revert | no | yes
unrevert | no | yes
pull | yes | yes
unpull | yes | yes
apply | yes | yes
push6.1 | no | no
send6.2 | no | no
put6.3 | no | no

# Common options to darcs commands

--help
Every `COMMAND` accepts `--help` as an argument, which tells it to provide a bit of help. Among other things, this help always provides an accurate listing of the options available with that command, and is guaranteed never to be out of sync with the version of darcs you actually have installed (unlike this manual, which could be for an entirely different version of darcs).

    % darcs COMMAND --help

--disable
Every `COMMAND` accepts the `--disable` option, which can be used in `_darcs/prefs/defaults` to disable some commands in the repository. This can be helpful if you want to protect the repository from accidental use of advanced commands like unpull, unrecord or amend-record.

--verbose
Most commands also accept the `--verbose` option, which tells darcs to provide additional output. The amount of verbosity varies from command to command.

--repodir
Another common option is the `--repodir` option, which allows you to specify the directory of the repository in which to perform the command. This option is used with commands, such as whatsnew, that ordinarily would be performed within a repository directory, and allows you to use those commands without actually being in the repo directory when calling the command. This is useful when running darcs as a pipe, as might be the case when running apply from a mailer.

####
Selecting patches

Many commands operate on a patch or patches that have already been recorded. There are a number of options that specify which patches are selected for these operations: `--patch`, `--match`, `--tag`, and variants on these, which for `--patch` are `--patches`, `--from-patch`, and `--to-patch`. The `--patch` and `--tag` forms simply take (POSIX extended, aka `egrep`) regular expressions and match them against tag and patch names. `--match`, described below, allows more powerful patterns.

The plural forms of these options select all matching patches. The singular forms select the last matching patch. The range (from and to) forms select patches after or up to (both inclusive) the last matching patch.

These options use the current order of patches in the repository. darcs may reorder patches, so this is not necessarily the order of creation or the order in which patches were applied. However, as long as you are just recording patches in your own repository, they will remain in order.

#### Match

Currently `--match` accepts five primitive match types, although there are plans to expand it to match more patterns. Also, note that the syntax is still preliminary and subject to change.

The first match type accepts a literal string which is checked against the patch name. The syntax is

    darcs annotate --summary --match 'exact foo+bar'

This is useful for situations where a patch name contains characters that could be considered special for regular expressions.

The second match type accepts a regular expression which is checked against the patch name. The syntax is

    darcs annotate --summary --match 'name foo'

If you want to include spaces in the regular expression, it must be enclosed in double quotes (`"`), and currently there is no provision for escaping a double quote, so you have to choose between matching double quotes and matching spaces.

The third match type matches the darcs hash for each patch:

    darcs annotate --summary --match \
      'hash 20040403105958-53a90-c719567e92c3b0ab9eddd5290b705712b8b918ef'

This is intended to be used, for example, by programs allowing you to view darcs repositories (e.g. cgi scripts like viewCVS).

The fourth match type accepts a regular expression which is checked against the patch author. The syntax is

    darcs annotate --summary --match 'author foo'

There is also now rudimentary support for matching by date. This is done using commands such as

    darcs annotate --summary --match 'date "last week"'
    darcs annotate --summary --match 'date yesterday'
    darcs annotate --summary --match 'date today'
    darcs changes --from-match 'date "Sat Jun  30 11:31:30 EDT 2004"'

currently date matching always matches only the day itself. FIXME: It should be extended to match the time as well if the time is specified. In general, a lot of cleanup is needed in the date matching code.

Because the date matching is only by day, you may prefer to combine it with a more specific pattern.

    darcs annotate --summary --match 'date "last week" && name foo'

The `--match` pattern can include the logical operators `&&`, `||` and `not`, as well as grouping of patterns with parentheses. For example

    darcs annotate --summary --match 'name record && not name overrode'

--ignore-times
Darcs optimizes its operations by keeping track of the modification times of your files. This dramatically speeds up commands such as `whatsnew` and `record` which would otherwise require reading every file in the repo and comparing it with a reference version. However, there are times when this can cause problems, such as when running a series of darcs commands from a script, in which case often a file will be modified twice in the same second, which can lead to the second modification going unnoticed. The solution to such predicaments is the `--ignore-times` option, which instructs darcs not to trust the file modification times, but instead to check each file's contents explicitly.

--author
Several commands need to be able to identify you. Conventionally, you provide an email address for this purpose, which can include comments, e.g. ``David Roundy <droundy@abridgegame.org>''. The easiest way to do this is to define an environment variable `EMAIL` or `DARCS_EMAIL` (with the latter overriding the former). You can also override this using the `--author` flag to any command. Alternatively, you could set your email address on a per-repository basis using the ``defaults'' mechanism for ``ALL'' commands, as described in Appendix . Or, you could specify the author on a per-repository basis using the `_darcs/prefs/author` file as described in section .

Also, a global author file can be created with the name `.darcs/author` in your home directory. This file overrides the contents of the environment variables, but a repository-specific author file overrides the global author file.

--dont-compress, --compress
By default, darcs commands that write patches to disk will compress the patch files. If you don't want this, you can choose the `--dont-compress` option, which causes darcs not to compress the patch file.

--gui
Certain commands may have an optional graphical user interface. If such commands are supported, you can activate the graphical user interface by calling darcs with the `--gui` flag.

NOTE: The GUI is not currently functional, but is expected to re-appear in a future release.

--dry-run
The `--dry-run` option will cause darcs to not actually take the specified action. but only print what would have happened. Not all commands accept `--dry-run`, but those that do should accept the `--summary` option.

--summary, --no-summary
The `--summary` show a summary of the patches that would have been pulled/pushed/whatever. The format is similar to the output format of `cvs update` and looks like this:

    A  ./added_but_not_recorded.c
    A! ./added_but_not_recorded_conflicts.c
    a  ./would_be_added_if_look_for_adds_option_was_used.h

    M  ./modified.t -1 +1
    M! ./modified_conflicts.t -1 +1

    R  ./removed_but_not_recorded.c
    R! ./removed_but_not_recorded_conflicts.c

You can probably guess what the flags mean from the clever file names.

  `A` is for files that have been added but not recorded yet.
  `a` is for files found using the `--look-for-adds` option available for `whatsnew` and `record`. They have not been added yet, but would be added automatically if `--look-for-adds` were used with the next `record` command.

  `M` is for files that have been modified in the working directory but not recorded yet. The number of added and subtracted lines is also shown.

  `R` is for files that have been removed, but the removal is not recorded yet.

An exclamation mark appears next to any option that has a conflict.

####
Resolution of conflicts

To resolve conflicts using an external tool, you need to specify a command to use, e.g.

    --external-merge 'opendiff %1 %2 -ancestor %a -merge %o'.

The `%1` and `%2` are replaced with the two versions to be merged, `%a` is replaced with the common ancestor of the two version. Most importantly, `%o` is replaced with the name of the output file that darcs will require to be created holding the merged version. The above example works with the FileMerge.app tool that comes with Apple's developer tools. To use xxdiff, you would use

    --external-merge 'xxdiff -m -O -M %o %1 %a %2'

To use `kdiff3`, you can use

    --external-merge 'kdiff3 --output %o %a %1 %2'

If you figure out how to use darcs with another merge tool, please let me know what flags you used so I can mention it here.

Note that if you do use an external merge tool, most likely you will want to add to your defaults file (`_darcs/prefs/defaults` or `~/.darcs/prefs`, see ) a line such as

    ALL external-merge kdiff3 --output %o %a %1 %2

Note that the defaults file does not want quotes around the command.

--posthook=COMMAND, --no-posthook
To provide a command that should be run when even a darcs command completes successfully, use `--posthook` to give the command. This is useful in for people who want to have a command run whenever a patch is applied. Using `--no-posthook` will disable running the command.
--prompt-posthook, --run-posthook
These options control prompting before running the posthook. Use `--prompt-posthook` to force prompting before running the posthook command. For security reasons, this is the default. When defining a posthook for apply, you will need to use `--run-posthook` or else you will get an error, because the subprocess which runs the apply command cannot prompt the user.

# Options apart from darcs commands

--help, --extended-help
Calling darcs with just `--help` as an argument gives a brief summary of what commands are available. The `--extended-help` option gives a more technical summary of what the commands actually do.
--version, --exact-version
Calling darcs with the flag `--version` tells you the version of darcs you are using. Calling darcs with the flag `--exact-version` gives the precise version of darcs, even if that version doesn't correspond to a released version number. This is helpful with bug reports, especially when running with a ``latest'' version of darcs.
--commands
Similarly calling darcs with only `--commands` gives a simple list of available commands. This latter arrangement is primarily intended for the use of command-line autocompletion facilities, as are available in bash.

# Creating repositories

## darcs initialize

`Usage: darcs initialize [OPTION]...`

Options:

`--plain-pristine-tree`

Use a plain pristine tree [DEFAULT]

`--no-pristine-tree`

Use no pristine tree

Initialize a new source tree as a darcs repository.

Generally you will only call initialize once for each project you work on, and calling it is just about the first thing you do. Just make sure you are in the main directory of the project, and initialize will set up all the directories and files darcs needs in order to start keeping track of revisions for your project.

The `initialize` command actually follows a very simple procedure. It creates the directories `_darcs`, `_darcs/current` (or `_darcs/pristine`) and `_darcs/patches`, and then creates an empty file, `_darcs/inventory`. However, it is strongly recommended that you use `darcs initialize` to do this, as this procedure may change in a future version of darcs.

--no-pristine-tree
In order to save disk space, you can use `initialize` with the `--no-pristine-tree` flag to create a repository with no pristine tree. Please see Section for more information.

## darcs get

`Usage: darcs get [OPTION]... <REPOSITORY> [<DIRECTORY>]`

Options:

`--repo-name DIRECTORY`

path of output directory

`--partial`

get partial repository using checkpoint

`--complete`

get a complete copy of the repository

`--to-match PATTERN`

select changes up to a patch matching PATTERN

`--to-patch REGEXP`

select changes up to a patch matching REGEXP

`--tag REGEXP`

select tag matching REGEXP

`--context FILENAME`

version specified by the context in FILENAME

`-v`

`--verbose`

give verbose output

`-q`

`--quiet`

suppress informational output

`--standard-verbosity`

neither verbose nor quiet output

`--set-default`

set default repository [DEFAULT]

`--no-set-default`

don't set default repository

`--set-scripts-executable`

make scripts executable

`--dont-set-scripts-executable`

don't make scripts executable

`--plain-pristine-tree`

Use a plain pristine tree [DEFAULT]

`--no-pristine-tree`

Use no pristine tree

If the remote repo and the current directory are in the same filesystem and that filesystem supports hard links, get will create hard links for the patch files, which means that the additional storage space needed will be minimal. This is very good for your disk usage (and for the speed of running get), so if you want multiple copies of a repository, I strongly recommend first running `darcs get` to get yourself one copy, and then running `darcs get` on that copy to make any more you like. The only catch is that the first time you run `darcs push` or `darcs pull` from any of these second copies, by default they will access your first copy--which may not be what you want.

You may specify the name of the repository created by providing a second argument to get, which is a directory name.

--context, --tag, --to-patch, --to-match
If you want to get a specific version of a repository, you have a few options. You can either use the `--tag`, `--to-patch` or `--to-match` options, or you can use the `--context=FILENAME` option, which specifies a file containing a context generated with `darcs changes --context`. This allows you (for example) to include in your compiled program an option to output the precise version of the repository from which it was generated, and then perhaps ask users to include this information in bug reports.

Note that when specifying `--to-patch` or `--to-match`, you may get a version of your code that has never before been seen, if the patches have gotten themselves reordered. If you ever want to be able to precisely reproduce a given version, you need either to tag it or create a context file.

--partial
Only get the patches since the last checkpoint. This will save time, bandwidth and disk space, at the expense of losing the history before the checkpoint.

--no-pristine-tree
In order to save disk space, you can use `get` with the `--no-pristine-tree` flag to create a repository with no pristine tree. Please see Section for more information.

## darcs put

`Usage: darcs put [OPTION]... <NEW REPOSITORY>`

Options:

`-v`

`--verbose`

give verbose output

`-q`

`--quiet`

suppress informational output

`--standard-verbosity`

neither verbose nor quiet output

`--repodir DIRECTORY`

specify the repository directory in which to run

`--to-match PATTERN`

select changes up to a patch matching PATTERN

`--to-patch REGEXP`

select changes up to a patch matching REGEXP

`--tag REGEXP`

select tag matching REGEXP

`--context FILENAME`

version specified by the context in FILENAME

`--apply-as USERNAME`

apply patch as another user using sudo

`--apply-as-myself`

don't use sudo to apply as another user [DEFAULT]

`--plain-pristine-tree`

Use a plain pristine tree [DEFAULT]

`--no-pristine-tree`

Use no pristine tree

Put is the opposite of get. Put copies the content of the current repository and puts it in a newly created repository.

WARNING: Put is far less optimized than get, especially for local repositories. We recommend avoiding use of put except for small repositories.

Put is used when you already have a repository and want to make a copy of it. A typical use-case is when you want to branch your project.

Put works by first initializing a repository. If the new repository is not on the local file system then darcs will login to the remote host and run `darcs init` there. After the new repository is created all selected patches will be pushed just as with the command `push`.

--apply-as

If you give the `--apply-as` flag, darcs will use sudo to apply the changes as a different user. This can be useful if you want to set up a system where several users can modify the same repository, but you don't want to allow them full write access. This isn't secure against skilled malicious attackers, but at least can protect your repository from clumsy, inept or lazy users.

--context, --tag, --to-patch, --to-match
If you want to put a specific version of a repository, you have a few options. You can either use the `--tag`, `--to-patch` or `--to-match` options, or you can use the `--context=FILENAME` option, which specifies a file containing a context generated with `darcs changes --context`. This allows you (for example) to include in your compiled program an option to output the precise version of the repository from which it was generated, and then perhaps ask users to include this information in bug reports.

Note that when specifying `--to-patch` or `--to-match`, you may get a version of your code that has never before been seen, if the patches have gotten themselves reordered. If you ever want to be able to precisely reproduce a given version, you need either to tag it or create a context file.

# Modifying the contents of a repo

## darcs add

`Usage: darcs add [OPTION]... <FILE or DIRECTORY> ...`

Options:

`--boring`

don't skip boring files

`--case-ok`

don't refuse to add files differing only in case

`-r`

`--recursive`

add contents of subdirectories

`--not-recursive`

don't add contents of subdirectories

`--date-trick`

add files with date appended to avoid conflict. [EXPERIMENTAL]

`--no-date-trick`

don't use experimental date appending trick. [DEFAULT]

`-v`

`--verbose`

give verbose output

`-q`

`--quiet`

suppress informational output

`--standard-verbosity`

neither verbose nor quiet output

`--repodir DIRECTORY`

specify the repository directory in which to run

`--dry-run`

don't actually take the action

Add needs to be called whenever you add a new file or directory to your project. Of course, it also needs to be called when you first create the project, to let darcs know which files should be kept track of.

Darcs will refuse to add a file or directory that differs from an existing one only in case. This is because the HFS+ file system used on under MacOS treats such files as being one and the same.

You can not add symbolic links to darcs. If you try to do that, darcs will refuse and print an error message. Perhaps you want to make symbolic links to the files in darcs instead?

--boring

By default darcs will ignore all files that match any of the boring patterns. If you want to add such a file anyway you must use the `--boring` option.

--date-trick

The `--date-trick` option allows you to enable an experimental trick to make add conflicts, in which two users each add a file or directory with the same name, less problematic. While this trick is completely safe, it is not clear to what extent it is beneficial.

## darcs remove

`Usage: darcs remove [OPTION]... <FILE or DIRECTORY> ...`

Options:

`-v`

`--verbose`

give verbose output

`--standard-verbosity`

don't give verbose output

`--repodir DIRECTORY`

specify the repository directory in which to run

Remove should be called when you want to remove a file from your project, but don't actually want to delete the file. Otherwise just delete the file or directory, and darcs will notice that it has been removed. Be aware that the file WILL be deleted from any other copy of the repo to which you later apply the patch.

## darcs mv

`Usage: darcs mv [OPTION]... [FILE or DIRECTORY]...`

Options:

`--case-ok`

don't refuse to add files differing only in case

`-v`

`--verbose`

give verbose output

`--standard-verbosity`

don't give verbose output

`--repodir DIRECTORY`

specify the repository directory in which to run

Darcs mv needs to be called whenever you want to move files or directories. Unlike remove, mv actually performs the move itself in your working copy. This is why ``mv'' isn't called ``move'', since it is really almost equivalent to the unix command ``mv''. I could add an equivalent command named ``move'' for those who like vowels.

--case-ok

Darcs mv will by default refuse to rename a file if there already exists a file having the same name apart from case. This is because doing so could create a repository that could not be used on file systems that are case insensitive (such as Apples HFS+). You can override this by with the flag `--case-ok`.

## darcs replace

`Usage: darcs replace [OPTION]... <OLD> <NEW> <FILE> ...`

Options:

`--token-chars "[CHARS]"`

define token to contain these characters

`--force`

proceed with replace even if 'new' token already exists

`--no-force`

don't force the replace if it looks scary

`-v`

`--verbose`

give verbose output

`--standard-verbosity`

don't give verbose output

Replace allows you to change a specified token wherever it occurs in the specified files. The replace is encoded in a special patch and will merge as expected with other patches. Tokens here are defined by a regexp specifying the characters which are allowed. By default a token corresponds to a C identifier.

The default regexp is `[A-Za-z_0-9]`), and if one of your tokens contains a ``-`' or ``.`', you will then (by default) get the ``filename'' regexp, which is `[A-Za-z_0-9\-\.]`.

--token-chars

If you prefer to choose a different set of characters to define your token (perhaps because you are programming in some other language), you may do so with the `--token-chars` option. You may prefer to define tokens in terms of delimiting characters instead of allowed characters using a flag such as `--token-chars '[^ \n\t]'`, which would define a token as being white-space delimited.

If you do choose a non-default token definition, I recommend using `_darcs/prefs/defaults` to always specify the same `--token-chars`, since your replace patches will be better behaved (in terms of commutation and merges) if they have tokens defined in the same way.

When using darcs replace, the ``new'' token may not already appear in the file--if that is the case, the replace change would not be invertible. This limitation holds only on the already-recorded version of the file.

There is a potentially confusing difference, however, when a replace is used to make another replace possible:

    % darcs replace newtoken aaack ./foo.c
    % darcs replace oldtoken newtoken ./foo.c
    % darcs record

will be valid, even if `newtoken` and `oldtoken` are both present in the recorded version of foo.c, while the sequence

    % [manually edit foo.c replacing newtoken with aaack]
    % darcs replace oldtoken newtoken ./foo.c

will fail because ``newtoken'' still exists in the recorded version of `foo.c`. The reason for the difference is that when recording, a ``replace'' patch always is recorded before any manual changes, which is usually what you want, since often you will introduce new occurrences of the ``newtoken'' in your manual changes. In contrast, multiple ``replace'' changes are recorded in the order in which they were made.

# Working with changes

## darcs record

`Usage: darcs record [OPTION]... [FILE or DIRECTORY]...`

Options:

`-m`

`--patch-name PATCHNAME`

name of patch

`-A`

`--author EMAIL`

specify author id

`--logfile FILE`

give patch name and comment in file

`--delete-logfile`

delete the logfile when done

`-v`

`--verbose`

give verbose output

`--standard-verbosity`

don't give verbose output

`--no-test`

don't run the test script

`--test`

run the test script

`--leave-test-directory`

don't remove the test directory

`--remove-test-directory`

remove the test directory

`--compress`

create compressed patches

`--dont-compress`

don't create compressed patches

`-a`

`--all`

answer yes to all patches

`--pipe`

expect to receive input from a pipe

`--interactive`

prompt user interactively

`--ask-deps`

ask for extra dependencies

`--no-ask-deps`

don't ask for extra dependencies

`--edit-long-comment`

Edit the long comment by default

`--skip-long-comment`

Don't give a long comment

`--prompt-long-comment`

Prompt for whether to edit the long comment

`--ignore-times`

don't trust the file modification times

`-l`

`--look-for-adds`

In addition to modifications, look for files that are not boring, and thus are potentially pending addition

`--dont-look-for-adds`

Don't look for any files or directories that could be added, and don't add them automatically

`--repodir DIRECTORY`

specify the repository directory in which to run

If you provide one or more files or directories as additional arguments to record, you will only be prompted to changes in those files or directories. Each patch is given a name, which typically would consist of a brief description of the changes. This name is later used to describe the patch. The name must fit on one line (i.e. cannot have any embedded newlines). If you have more to say, stick it in the log. The patch is also flagged with the author of the change, taken by default from the `DARCS_EMAIL` environment variable, and if that doesn't exist, from the `EMAIL` environment variable. The date on which the patch was recorded is also included. Currently there is no provision for keeping track of when a patch enters a given repository. Finally, each changeset should have a full log (which may be empty). This log is for detailed notes which are too lengthy to fit in the name. If you answer that you do want to create a comment file, darcs will open an editor so that you can enter the comment in. The choice of editor proceeds as follows. If one of the `$DARCS_EDITOR`, `$VISUAL` or `$EDITOR` environment variables is defined, its value is used (with precedence proceeding in the order listed). If not, ``vi'', ``emacs'', ``emacs -nw'' and ``nano'' are tried in that order.

--logfile

If you wish, you may specify the patch name and log using the `--logfile` flag. If you do so, the first line of the specified file will be taken to be the patch name, and the remainder will be the ``long comment''. This feature can be especially handy if you have a test that fails several times on the record (thus aborting the record), so you don't have to type in the long comment multiple times. The file's contents will override the `--patch-name` option.

--ask-deps

Each patch may depend on any number of previous patches. If you choose to make your patch depend on a previous patch, that patch is required to be applied before your patch can be applied to a repo. This can be used, for example, if a piece of code requires a function to be defined, which was defined in an earlier patch.

If you want to manually define any dependencies for your patch, you can use the `--ask-deps` flag, and darcs will ask you for the patch's dependencies.

--no-test, --test

If you configure darcs to run a test suite, darcs will run this test on the recorded repo to make sure it is valid. Darcs first creates a pristine copy of the source tree (in a temporary directory), then it runs the test, using its return value to decide if the record is valid. If it is not valid, the record will be aborted. This is a handy way to avoid making stupid mistakes like forgetting to `darcs add' a new file. It also can be tediously slow, so there is an option (`--no-test`) to skip the test.

--pipe

If you run record with the `--pipe` option, you will be prompted for the patch name, patch date and the long comment. The long comment will extend until the end of file of stdin is reached (ctrl-D on unixy systems). This interface is intended for scripting darcs, in particular for writing repository conversion scripts. The prompts are intended mostly as useful guide (since scripts won't need them), to help you understand the format in which to provide the input.

--interactive

By default, `record` works interactively. Probably you only thing you need to know about using this is that you can press `?` at the prompt to be shown a list of the rest the options and what they do. The rest should be clear from there. Here's a ``screenshot'' to demonstrate:

    hunk ./hello.pl +2
    +#!/usr/bin/perl
    +print "Hello World!\n";
    Shall I record this patch? (2/2) [ynWsfqadjk], or ? for help: ?
    How to use record...
    y: record this patch
    n: don't record it
    w: wait and decide later, defaulting to no

    s: don't record the rest of the changes to this file
    f: record the rest of the changes to this file

    d: record selected patches
    a: record all the remaining patches
    q: cancel record

    j: skip to next patch
    k: back up to previous patch
    h or ?: show this help

    <Space>: accept the current default (which is capitalized)

What you can't see in that ``screenshot'' is that `darcs` will also try to use color in your terminal to make the output even easier to read.

## darcs pull

`Usage: darcs pull [OPTION]... [REPOSITORY]`

Options:

`--matches PATTERN`

select patches matching PATTERN

`-p`

`--patches REGEXP`

select patches matching REGEXP

`-t`

`--tags REGEXP`

select tags matching REGEXP

`-a`

`--all`

answer yes to all patches

`--interactive`

prompt user interactively

`--external-merge COMMAND`

Use external tool to merge conflicts

`--compress`

create compressed patches

`--dont-compress`

don't create compressed patches

`--test`

run the test script

`--no-test`

don't run the test script

`--dry-run`

don't actually take the action

`-s`

`--summary`

summarize changes

`--no-summary`

don't summarize changes

`-v`

`--verbose`

give verbose output

`-q`

`--quiet`

suppress informational output

`--standard-verbosity`

neither verbose nor quiet output

`--ignore-times`

don't trust the file modification times

`--no-deps`

don't automatically fulfill dependencies

`--set-default`

set default repository [DEFAULT]

`--no-set-default`

don't set default repository

`--repodir DIRECTORY`

specify the repository directory in which to run

`--set-scripts-executable`

make scripts executable

`--dont-set-scripts-executable`

don't make scripts executable

Pull is used to bring changes made in another repo into the current repo (that is, either the one in the current directory, or the one specified with the -repodir option). Pull allows you to bring over all or some of the patches that are in that repo but not in this one. Pull accepts an argument, which is the URL from which to pull, and when called without an argument, pull will use the repository from which you have most recently either pushed or pulled.

--external-merge

You can use an external interactive merge tool to resolve conflicts with the flag `--external-merge`. For more details see subsection .

--matches, --no-deps, --patches, --tags

The `--patches`, `--matches`, and `--tags` options can be used to select which patches to pull, as described in subsection . darcs will silently pull along any other patches upon which the selected patches depend. So `--patches bugfix` means ``pull all the patches with `bugfix' in their name, along with any patches they require.'' If you really only want the patches with `bugfix' in their name, you should use the `--no-deps` option, which makes darcs pull in only the selected patches which have no dependencies (apart from other selected patches).

--no-test, --test

If you specify the `--test` option, pull will run the test (if a test exists) on a scratch copy of the repo contents prior to actually performing the pull. If the test fails, the pull will be aborted.

--verbose

Adding the `--verbose` option causes another section to appear in the output which also displays a summary of patches that you have and the remote repo lacks. Thus, the following syntax can be used to show you all the patch differences between two repos:

    darcs pull --dry-run --verbose

## darcs push

`Usage: darcs push [OPTION]... [REPOSITORY]`

Options:

`-v`

`--verbose`

give verbose output

`-q`

`--quiet`

suppress informational output

`--standard-verbosity`

neither verbose nor quiet output

`--matches PATTERN`

select patches matching PATTERN

`-p`

`--patches REGEXP`

select patches matching REGEXP

`-t`

`--tags REGEXP`

select tags matching REGEXP

`-a`

`--all`

answer yes to all patches

`--interactive`

prompt user interactively

`--apply-as USERNAME`

apply patch as another user using sudo

`--apply-as-myself`

don't use sudo to apply as another user [DEFAULT]

`--dry-run`

don't actually take the action

`-s`

`--summary`

summarize changes

`--no-summary`

don't summarize changes

`--repodir DIRECTORY`

specify the repository directory in which to run

`--set-default`

set default repository [DEFAULT]

`--no-set-default`

don't set default repository

Push is the opposite of pull. Push allows you to copy changes from the current repository into another repository.

For obvious reasons, you can only push to repositories to which you have write access. In addition, you can only push to repos that you access either on the local file system or with ssh. In order to apply with ssh, darcs must also be installed on the remote computer. The command invoked to run ssh may be configured by the `DARCS_SSH` environment variable (see subsection ). The command invoked via ssh is always `darcs`, i.e., the darcs executable must be in the default path on the remote machine.

Push works by creating a patch bundle, and then running darcs apply in the target repository using that patch bundle. This means that the default options for apply in the target repository (such as, for example, `--test`) will affect the behavior of push. This also means that push is somewhat less efficient than pull.

When you receive an error message such as

    bash: darcs: command not found

then this means that the darcs on the remote machine could not be started. Make sure that the darcs executable is called `darcs` and is found in the default path. The default path can be different in interactive and in non-interactive shells. Say

    ssh login@remote.machine darcs

to try whether the remote darcs can be found, or

    ssh login@remote.machine 'echo $PATH'

(note the single quotes) to check the default path.

--apply-as

If you give the `--apply-as` flag, darcs will use sudo to apply the changes as a different user. This can be useful if you want to set up a system where several users can modify the same repository, but you don't want to allow them full write access. This isn't secure against skilled malicious attackers, but at least can protect your repository from clumsy, inept or lazy users.

--matches, --patches, --tags

The `--patches`, `--matches`, and `--tags` options can be used to select which patches to push, as described in subsection . darcs will silently push along any other patches upon which the selected patches depend.

When there are conflicts, the behavior of push is determined by the default flags to `apply` in the target repository. Most commonly, for pushed-to repositories, you'd like to have `--dont-allow-conflicts` as a default option to apply (by default, it is already the default...). If this is the case, when there are conflicts on push, darcs will fail with an error message. You can then resolve by pulling the conflicting patch, recording a resolution and then pushing the resolution together with the conflicting patch.

Darcs does not have an explicit way to tell you which patch conflicted, only the file name. You may want to pull all the patches from the remote repo just to be sure. If you don't want to do this in your working directory, you can create another darcs working directory for this purpose.

If you want, you could set the target repo to use `--allow-conflicts`. In this case conflicting patches will be applied, but the conflicts will not be marked in the working directory.

If, on the other hand, you have `--mark-conflicts` specified as a default flag for apply in the target repository, when there is a conflict, it will be marked in the working directory of the target repository. In this case, you should resolve the conflict in the target repository itself.

## darcs send

`Usage: darcs send [OPTION]... [REPOSITORY]`

Options:

`-v`

`--verbose`

give verbose output

`-q`

`--quiet`

suppress informational output

`--standard-verbosity`

neither verbose nor quiet output

`--matches PATTERN`

select patches matching PATTERN

`-p`

`--patches REGEXP`

select patches matching REGEXP

`-t`

`--tags REGEXP`

select tags matching REGEXP

`-a`

`--all`

answer yes to all patches

`--interactive`

prompt user interactively

`--from EMAIL`

specify email address

`-A`

`--author EMAIL`

specify author id

`--to EMAIL`

specify destination email

`--cc EMAIL`

mail results to additional EMAIL(s). Requires -reply

`-o`

`--output FILE`

specify output filename

`--sign`

sign the patch with your gpg key

`--sign-as KEYID`

sign the patch with a given keyid

`--sign-ssl IDFILE`

sign the patch using openssl with a given private key

`--dont-sign`

do not sign the patch

`-u`

`--unified`

output patch in a darcs-specific format similar to diff -u

`--dry-run`

don't actually take the action

`-s`

`--summary`

summarize changes

`--no-summary`

don't summarize changes

`--context FILENAME`

send to context stored in FILENAME

`--edit-description`

edit the patch bundle description

`--set-default`

set default repository [DEFAULT]

`--no-set-default`

don't set default repository

`--repodir DIRECTORY`

specify the repository directory in which to run

`--sendmail-command COMMAND`

specify sendmail command

Send is used to prepare a bundle of patches that can be applied to a target repository. Send accepts the URL of the repository as an argument. When called without an argument, send will use the most recent repository that was either pushed to, pulled from or sent to. By default, the patch bundle is sent by email, although you may save it to a file.

--unified

If you want to create a patches having context, you can use the `--unified` option, which create output vaguely reminiscent of `diff -u`. This format is still darcs-specific and should not be expected to apply cleanly by `patch`.

--output, --to, --cc

The `--output` and `--to` flags determine what darcs does with the patch bundle after creating it. If you provide an `--output` argument, the patch bundle is saved to that file. If you give one or more `--to` arguments, the bundle of patches is emailed to those addresses.

If you don't provide either a `--output` or a `--to` flag, darcs will look at the contents of the `_darcs/prefs/email` file in the target repository (if it exists), and send the patch by email to that address. In this case, you may use the `--cc` option to specify additional recipients without overriding the default repository email address.

If there is no email address associated with the repository, darcs will prompt you for an email address.

--matches, --patches, --tags

The `--patches`, `--matches`, and `--tags` options can be used to select which patches to send, as described in subsection . darcs will silently send along any other patches upon which the selected patches depend.

--edit-description

If you want to include a description or explanation along with the bundle of patches, you need to specify the `--edit-description` flag, which will cause darcs to open up an editor with which you can compose an email to go along with your patches.

--sendmail-command

If you want to use a command different from the default one for sending mails, you need to specify a commandline with the `--sendmail-command` option. The commandline can contain some format specifiers which are replaced by the actual values. Accepted format specifiers are `%s` for subject, `%t` for to, `%c` for cc, `%b` for the body of the mail, `%f` for from, `%a` for the patch bundle and the same specifiers in uppercase for the urlencoded values. Additionally you can add `%<` to the end of the commandline if the command expects the complete mail on standard input. E.g. the commandlines for evolution and msmtp look like this:

    evolution "mailto:%T?subject=%S&attach=%A&cc=%C&body=%B"
    msmtp %t %<

## darcs apply

`Usage: darcs apply [OPTION]... <PATCHFILE>`

Options:

`--verify PUBRING`

verify that the patch was signed by a key in PUBRING

`--verify-ssl KEYS`

verify using openSSL with authorized keys from file 'KEYS'

`--no-verify`

don't verify patch signature

`--reply FROM`

reply to email-based patch using FROM address

`--cc EMAIL`

mail results to additional EMAIL(s). Requires -reply

`-v`

`--verbose`

give verbose output

`--standard-verbosity`

don't give verbose output

`--ignore-times`

don't trust the file modification times

`--compress`

create compressed patches

`--dont-compress`

don't create compressed patches

`-a`

`--all`

answer yes to all patches

`--interactive`

prompt user interactively

`--mark-conflicts`

mark conflicts

`--allow-conflicts`

allow conflicts, but don't mark them

`--external-merge COMMAND`

Use external tool to merge conflicts

`--no-resolve-conflicts`

equivalent to -dont-allow-conflicts, for backwards compatibility

`--dont-allow-conflicts`

fail on patches that create conflicts [DEFAULT]

`--no-test`

don't run the test script

`--test`

run the test script

`--happy-forwarding`

forward unsigned messages without extra header

`--leave-test-directory`

don't remove the test directory

`--remove-test-directory`

remove the test directory

`--repodir DIRECTORY`

specify the repository directory in which to run

`--sendmail-command COMMAND`

specify sendmail command

`--set-scripts-executable`

make scripts executable

`--dont-set-scripts-executable`

don't make scripts executable

Apply is used to apply a bundle of patches to this repository. Such a bundle may be created using send.

Darcs apply accepts a single argument, which is the name of the patch file to be applied. If you omit this argument, the patch is read from standard input.6.4 This allows you to use apply with a pipe from your email program, for example.

--verify

If you specify the `--verify PUBRING` option, darcs will check that the patch was gpg-signed by a key which is in `PUBRING`, and will refuse to apply the patch otherwise.

--cc, --reply

If you give the `--reply FROM` option to darcs apply, it will send the results of the application to the sender of the patch. This only works if the patch is in the form of an email with its headers intact, so that darcs can actually know the origin of the patch. The reply email will indicate whether or not the patch was successfully applied. The `FROM` flag is the email address that will be used as the ``from'' address when replying. If the darcs apply is being done automatically, it is important that this address not be the same as the address at which the patch was received in order to avoid automatic email loops.

If you want to also send the apply email to another address (for example, to create something like a ``commits'' mailing list), you can use the `--cc` option to specify additional recipients. Note that the `--cc` option requires the `--reply` option, which provides the ``From'' address.

The `--reply` feature of apply is intended primarily for two uses. When used by itself, it is handy for when you want to apply patches sent to you by other developers so that they will know when their patch has been applied. For example, in my `.muttrc` (the config file for my mailer) I have:

    macro pager A "<pipe-entry>darcs apply --verbose \
            --reply droundy@abridgegame.org --repodir ~/darcs

which allows me to apply a patch to darcs directly from my mailer, with the originator of that patch being sent a confirmation when the patch is successfully applied. NOTE: For some reason mutt seems to set the umask such that patches created with the above macro are not world-readable. I'm not sure why this is, but use it with care.

When used in combination with the `--verify` option, the `--reply` option allows for a nice pushable repository. When these two options are used together, any patches that don't pass the verify will be forwarded to the `FROM` address of the `--reply` option. This allows you to set up a repository so that anyone who is authorized can push to it and have it automatically applied, but if a stranger pushes to it, the patch will be forwarded to you. Please (for your own sake!) be certain that the `--reply FROM` address is different from the one used to send patches to a pushable repository, since otherwise an unsigned patch will be forwarded to the repository in an infinite loop.

If you use ``darcs apply --verify PUBRING --reply`' to create a pushable repo by applying patches automatically as they are received by email, you will also want to use the `--dont-allow-conflicts` option.

--dont-allow-conflicts
The `--dont-allow-conflicts` flag causes apply to fail when applying a patch would cause conflicts. This flag is recommended on repositories which will be pushed to or sent to.

--allow-conflicts

`--allow-conflicts` will allow conflicts, but will keep the local and recorded versions in sync on the repo. This means the conflict will exist in both locations until it is resolved.

--mark-conflicts

`--mark-conflicts` will add conflict markers to illustrate the the conflict.

--external-merge

You can use an external interactive merge tool to resolve conflicts with the flag `--external-merge`. For more details see subsection .

--all, --gui, --interactive

If you provide the `--interactive` or `--gui` flag, darcs will ask you for each change in the patch bundle whether or not you wish to apply that change. The opposite is the `--all` flag, which can be used to override an interactive or gui which might be set in your ``defaults'' file.

NOTE: The GUI is not currently functional, but is expected to re-appear in a future release.

--sendmail-command

If you want to use a command different from the default one for sending mails, you need to specify a commandline with the `--sendmail-command` option. The commandline can contain the format specifier `%t` for to and you can add `%<` to the end of the commandline if the command expects the complete mail on standard input. E.g. the commandline for msmtp looks like this:

    msmtp %t %<

--no-test, --test

If you specify the `--test` option, apply will run the test (if a test exists) prior to applying the patch. If the test fails, the patch is not applied. In this case, if the `--reply` option was used, the results of the test are send in the reply email. You can also specify the `--no-test` option, which will override the `--test` option, and prevent the test from being run. This is helpful when setting up a pushable repository, to keep users from running code.

# Seeing what you've done

##
darcs whatsnew

`Usage: darcs whatsnew [OPTION]... [FILE or DIRECTORY]...`

Options:

`-v`

`--verbose`

give verbose output

`--standard-verbosity`

don't give verbose output

`-s`

`--summary`

summarize changes

`--no-summary`

don't summarize changes

`-u`

`--unified`

output patch in a darcs-specific format similar to diff -u

`--ignore-times`

don't trust the file modification times

`-l`

`--look-for-adds`

In addition to modifications, look for files that are not boring, and thus are potentially pending addition

`--dont-look-for-adds`

Don't look for any files or directories that could be added, and don't add them automatically

`--boring`

don't skip boring files

`--repodir DIRECTORY`

specify the repository directory in which to run

Display unrecorded changes in the working copy. whatsnew gives you a view of what changes you've made in your working copy that haven't yet been recorded. The changes are displayed in darcs patch format. Note that -look-for-adds implies -summary usage. Darcs whatsnew will return a non-zero value if there are no changes, which can be useful if you just want to see in a script if anything has been modified. If you want to see some context around your changes, you can use the `-u` option, to get output similar to the unidiff format.

If you give one or more file or directory names as an argument to whatsnew, darcs whatsnew will output only changes to those files or to files in those directories.

## darcs changes

`Usage: darcs changes [OPTION]... [FILE or DIRECTORY]...`

Options:

`--to-match PATTERN`

select changes up to a patch matching PATTERN

`--to-patch REGEXP`

select changes up to a patch matching REGEXP

`--to-tag REGEXP`

select changes up to a tag matching REGEXP

`--from-match PATTERN`

select changes starting with a patch matching PATTERN

`--from-patch REGEXP`

select changes starting with a patch matching REGEXP

`--from-tag REGEXP`

select changes starting with a tag matching REGEXP

`--last NUMBER`

select the last NUMBER patches

`--matches PATTERN`

select patches matching PATTERN

`-p`

`--patches REGEXP`

select patches matching REGEXP

`-t`

`--tags REGEXP`

select tags matching REGEXP

`--context`

give output suitable for get -context

`--xml-output`

generate XML formatted output

`--human-readable`

give human-readable output

`-s`

`--summary`

summarize changes

`--no-summary`

don't summarize changes

`-v`

`--verbose`

give verbose output

`-q`

`--quiet`

suppress informational output

`--standard-verbosity`

neither verbose nor quiet output

`--reverse`

show changes in reverse order

`--repo URL`

specify the repository URL

Changes gives a changelog style summary of the repo history, including options for altering how the patches are selected and displayed.

When given one or more files or directories as an argument, changes lists only those patches which affect those files or the contents of those directories, or of course the directories themselves. This includes changes that happened to files before they were moved or renamed.

--from-match, --from-patch, --from-tag

If changes is given a `--from-patch`, `--from-match`, or `--from-tag` option, it outputs only those changes since that tag or patch.

Without any options to limit the scope of the changes, history will be displayed going back as far as possible.

--context, --human-readable, --xml-output

When given the `--context` flag, darcs changes outputs sufficient information which will allow the current state of the repository to be recreated at a later date. This information should generally be piped to a file, and then can be used later in conjunction with `darcs get --context` to recreate the current version. Note that while the `--context` flag may be used in conjunction with `--xml-output` or `--human-readable`, in neither case will darcs get be able to read the output. On the other hand, sufficient information will be output for a knowledgeable human to recreate the current state of the repository.

##
darcs query manifest

`Usage: darcs query manifest [OPTION]...`

Options:

`--files`

include files in output [DEFAULT]

`--no-files`

do not include files in output

`--directories`

include directories in output

`--no-directories`

do not include directories in output [DEFAULT]

`--pending`

reflect pending patches in output [DEFAULT]

`--no-pending`

only included recorded patches in output

`-0`

`--null`

separate file names by NUL characters

`--repodir DIRECTORY`

specify the repository directory in which to run

The manifest command lists the version-controlled files in the working copy.

By default (and if the `--pending` option is specified), the effect of pending patches on the repository is taken into account. In other words, if you add a file using `darcs add`, it immediately appears in the output of `query manifest`, even if it is not yet recorded. If you specify the `--no-pending` option, `query manifest` will only list recorded files (and directories).

The `--files` and `--directories` options control whether files and directories are included in the output. The `--no-files` and `--no-directories` options have the reverse effect. The default is to include files, but not directories.

If you specify the `--null` option, the file names are written to standard output in unescaped form, and separated by ASCII NUL bytes. This format is suitable for further automatic processing (for example, using `xargs -0`).

# More advanced commands

## darcs tag

`Usage: darcs tag [OPTION]... [TAGNAME]`

Options:

`-m`

`--patch-name PATCHNAME`

name of patch

`-A`

`--author EMAIL`

specify author id

`--checkpoint`

create a checkpoint file

`--compress`

create compressed patches

`--dont-compress`

don't create compressed patches

`--pipe`

expect to receive input from a pipe

`--interactive`

prompt user interactively

`-v`

`--verbose`

give verbose output

`--standard-verbosity`

don't give verbose output

Tag is used to name a version of this repository (i.e. the whole tree). Tag differs from record in that it doesn't record any new changes, and it always depends on all patches residing in the repository when it is tagged. This means that one can later reproduce this version of the repository by calling, for example:

    % darcs get --tag "darcs 3.14" REPOLOCATION

Each tagged version has a version name. The version is also flagged with the person who tagged it (taken by default from the `DARCS_EMAIL' or `EMAIL' environment variable). The date is also included in the version information.

A tagged version automatically depends on all patches in the repo. This allows you to later reproduce precisely that version. The tag does this by depending on all patches in the repo, except for those which are depended upon by other tags already in the repo. In the common case of a sequential series of tags, this means that the tag depends on all patches since the last tag, plus that tag itself.

--checkpoint
The `--checkpoint` option allows the tag be used later with the `--partial` flag to `get` or `check`.

A partial repository only contains patches from after the checkpoint. A partial repository works just like a normal repository, but any command that needs to look at the contents of a missing patch will complain and abort.

--pipe

If you run tag with the `--pipe` option, you will be prompted for the tag name and date. This interface is intended for scripting darcs, in particular for writing repository conversion scripts. The prompts are intended mostly as useful guide (since scripts won't need them), to help you understand the format in which to provide the input. Here's an example of what the `--pipe` prompts looks like:

     What is the date? Mon Nov 15 13:38:01 EST 2004
     Who is the author? David Roundy
     What is the version name? 3.0
     Finished tagging patch 'TAG 3.0'

Using `tag` creates an entry in the repo history just like `record`. It will show up with `darcs changes` appearing in the format:

     tagged My Tag Name

Because the word 'tagged' is always prepended to the tag name, you can search for tag names by simply passing the output of `darcs changes` through `grep`:

     darcs changes | grep tagged

The above example would display all the tag names in use in the repo.

## darcs setpref

`Usage: darcs setpref [OPTION]... <PREF> <VALUE>`

Options:

Usage example:

    % darcs setpref test "echo I am not really testing anything."

Setpref allows you to set a preference value in a way that will propagate to other repositories.

Valid preferences are: test predist boringfile binariesfile. If you just want to set the pref value in your repository only, you can just edit ```_darcs/prefs/prefs`''. Changes you make in that file will be preserved.

The ```_darcs/prefs/prefs`'' holds the only preferences information that can propagate between repositories by pushes and pulls, and the only way this happens is when the setprefs command is used. Note that although prefs settings are included in patches, they are not fully version controlled. In particular, depending on the order in which a series of merges is perform, you may end up with a different final prefs configuration. In practice I don't expect this to be a problem, as the prefs usually won't be changed very often.

The following values are valid preferences options which can be configured using setpref:

- ``test'' -- the command to run as a test script.
- ``predist'' -- a command to run prior to tarring up a distribution tarball. Typically this would consist of autoconf and/or automake.
- ``boringfile'' -- the name of a file to read instead of the ``boring'' prefs file.
- ``binariesfile'' -- the name of a file to read instead of the ``binaries'' prefs file.

## darcs check

`Usage: darcs check [OPTION]...`

Options:

`--complete`

check the entire repository

`--partial`

check patches since latest checkpoint

`-v`

`--verbose`

give verbose output

`-q`

`--quiet`

suppress informational output

`--standard-verbosity`

neither verbose nor quiet output

`--no-test`

don't run the test script

`--test`

run the test script

`--leave-test-directory`

don't remove the test directory

`--remove-test-directory`

remove the test directory

`--repodir DIRECTORY`

specify the repository directory in which to run

Check the repository for consistency. Check verifies that the patches stored in the repository, when successively applied to an empty tree, properly recreate the stored pristine tree.

--complete, --partial

If you have a checkpoint of the repository (as is the case if you got the repo originally using `darcs get --partial`), by default darcs check will only verify the contents since the most recent checkpoint. You can change this behavior using the `--complete` flag.

If you like, you can configure your repository to be able to run a test suite of some sort. You can do this by using ``setpref'' to set the ``test'' value to be a command to run. e.g.

    % darcs setpref test "sh configure && make && make test"

Or, if you want to define a test specific to one copy of the repository, you could do this by editing the file `_darcs/prefs/prefs`.

--leave-test-directory, --remove-test-directory

Normally darcs deletes the directory in which the test was run afterwards. Sometimes (especially when the test fails) you'd prefer to be able to be able to examine the test directory after the test is run. You can do this by specifying the `--leave-test-directory` flag. Alas, there is no way to make darcs leave the test directory only if the test fails. The opposite of `--leave-test-directory` is `--remove-test-directory`, which could come in handy if you choose to make `--leave-test-directory` the default (see section ).

--no-test

If you just want to check the consistency of your repository without running the test, you can call darcs check with the `--no-test` option.

## darcs optimize

`Usage: darcs optimize [OPTION]...`

Options:

`--checkpoint`

create a checkpoint file

`--compress`

create compressed patches

`--dont-compress`

don't create compressed patches

`--uncompress`

uncompress patches

`-t`

`--tag TAGNAME`

name of version to checkpoint

`-v`

`--verbose`

give verbose output

`--standard-verbosity`

don't give verbose output

`--modernize-patches`

rewrite all patches in current darcs format

`--reorder-patches`

reorder the patches in the repository

`--sibling URL`

specify a sibling directory

`--relink`

relink random internal data to a sibling

`--relink-pristine`

relink pristine tree (not recommended)

Optimize can help to improve the performance of your repository in a number of cases.

Optimize always writes out a fresh copy of the inventory that minimizes the amount of inventory that need be downloaded when people pull from the repo.

Specifically, it breaks up the inventory on the most recent tag. This speeds up most commands when run remotely, both because a smaller file needs to be transfered (only the most recent inventory). It also because it gives a guarantee that all the patches prior to a given tag are included in that tag, so less commutation and history traversal is needed. This latter issue can become very important in large repositories.

--checkpoint, --tag

If you use the `--checkpoint` option optimize creates a checkpoint patch for a tag. You can specify the tag with the `--tag` option, or just let darcs choose the most recent tag. Note that optimize `--checkpoint` will fail when used on a ``partial'' repository. Also, the tag that is to be checkpointed must not be preceded by any patches that are not included in that tag. If that is the case, no checkpointing is done.

The created checkpoint is used by the `--partial` flag to `get` and `check`. This allows for users to retrieve a working repository with limited history with a savings of disk space and bandwidth.

--compress, --dont-compress, --uncompress

Some compression options are available, and are independent of the `--checkpoint` option.

By default the patches in the repository are compressed. These use less disk space, which translates into less bandwidth if repository is accessed remotely. Note that patches will always have the ".gz" extension whether they are compressed or not.

You may want to uncompress the patches when you've got enough disk space but are running out of physical memory.

If you give the `--compress` option, optimize will compress all the patches in the repository. Similarly, if you give the `--uncompress`, optimize will decompress all the patches in the repository. `--dont-compress` means "don't compress, but don't uncompress either". It would be useful if one of the compression options was provided as a default and you wanted to override it.

--modernize-patches

If you provide the `--modernize-patches` argument, darcs will convert obsolete patches into the current darcs format. This affects both the patch contents and the patch formatting.

Older versions of darcs formatted the long comments slightly differently, which can cause trouble with third-party tools that wish to parse the darcs patches, although darcs itself still reads the older patches fine. `--modernize-patches` standardizes the formatting of all patches.

In addition, very old versions of darcs created the ``merger 0.9'' patch type when there were conflicts. This patch type inherently had bugs which could lead to corruption, which is why it was phased out. `--modernize-patches` will convert old ``merger 0.9'' patches into an equivalent change (which will, however, commute differently).

--relink

The `--relink` and `--relink-pristine` options cause Darcs to relink files from a sibling. See Section .

--reorder-patches

The `--reorder-patches` option causes Darcs to create an optimal ordering of it's internal patch inventory. This may help to produce shorter 'context' lists when sending patches, and may improve performance for some other operations as well. You should not run `--reorder-patches` on a repository from which someone may be simultaneously pulling or getting, as this could lead to repository corruption.

# Undoing, redoing and running in circles

## darcs amend-record

`Usage: darcs amend-record [OPTION]... [FILE or DIRECTORY]...`

Options:

`--match PATTERN`

select patch matching PATTERN

`-p`

`--patch REGEXP`

select patch matching REGEXP

`-v`

`--verbose`

give verbose output

`--standard-verbosity`

don't give verbose output

`--no-test`

don't run the test script

`--test`

run the test script

`--leave-test-directory`

don't remove the test directory

`--remove-test-directory`

remove the test directory

`--compress`

create compressed patches

`--dont-compress`

don't create compressed patches

`-a`

`--all`

answer yes to all patches

`--interactive`

prompt user interactively

`--ignore-times`

don't trust the file modification times

`-l`

`--look-for-adds`

In addition to modifications, look for files that are not boring, and thus are potentially pending addition

`--dont-look-for-adds`

Don't look for any files or directories that could be added, and don't add them automatically

`--repodir DIRECTORY`

specify the repository directory in which to run

Amend-record is used to replace a patch with a newer version with additional changes.

If you provide one or more files or directories as additional arguments to amend-record, you will only be prompted to changes in those files or directories.

The old version of the patch is lost and the new patch will include both the old and the new changes. This is mostly the same as unrecording the old patch, fixing the changes and recording a new patch with the same name and description.

`amend-record` will modify the date of the recorded patch. WARNINGS: You should ONLY use `amend-record` on patches which only exist in a single repository! Also, running amend-record while another user is pulling from the same repo may cause repository corruption.

If you configure darcs to run a test suite, darcs will run this test on the amended repo to make sure it is valid. Darcs first creates a pristine copy of the source tree (in a temporary directory), then it runs the test, using its return value to decide if the amended change is valid.

## darcs rollback

`Usage: darcs rollback [OPTION]...`

Options:

`--match PATTERN`

select patch matching PATTERN

`-p`

`--patch REGEXP`

select patch matching REGEXP

`--compress`

create compressed patches

`--dont-compress`

don't create compressed patches

`-v`

`--verbose`

give verbose output

`--standard-verbosity`

don't give verbose output

`--repodir DIRECTORY`

specify the repository directory in which to run

Rollback is used to undo the effects of a single patch without actually deleting that patch. Instead, it applies the inverse patch as a new patch. Unlike unpull and unrecord (which accomplish a similar goal) rollback is perfectly safe, since it leaves in the repository a record of the patch it is removing. If you decide you didn't want to roll back a patch after all, you probably should use unrecord to undo the rollback, since like rollback, unrecord doesn't affect the working directory.

## darcs unrecord

`Usage: darcs unrecord [OPTION]...`

Options:

`--from-match PATTERN`

select changes starting with a patch matching PATTERN

`--from-patch REGEXP`

select changes starting with a patch matching REGEXP

`--from-tag REGEXP`

select changes starting with a tag matching REGEXP

`--last NUMBER`

select the last NUMBER patches

`--matches PATTERN`

select patches matching PATTERN

`-p`

`--patches REGEXP`

select patches matching REGEXP

`-t`

`--tags REGEXP`

select tags matching REGEXP

`-v`

`--verbose`

give verbose output

`--standard-verbosity`

don't give verbose output

`--compress`

create compressed patches

`--dont-compress`

don't create compressed patches

`--repodir DIRECTORY`

specify the repository directory in which to run

Unrecord does the opposite of record in that it makes the changes from patches active changes again which you may record or revert later. The working copy itself will not change.

Unrecord can be thought of as undo-record. If a record is followed by an unrecord, everything looks like before the record; all the previously unrecorded changes are back, and can be recorded again in a new patch. The unrecorded patch however is actually removed from your repository, so there is no way to record it again to get it back.6.5.

If you want to remove the change from the working copy too (where they otherwise will show up as unrecorded changes again), you'll also need to `darcs revert`. To do unrecord and revert in one go, you can use `darcs unpull`.

If you don't revert after unrecording, then the changes made by the unrecorded patches are left in your working tree. If these patches are actually from another repository, interaction (either pushes or pulls) with that repository may be massively slowed down, as darcs tries to cope with the fact that you appear to have made a large number of changes that conflict with those present in the other repository. So if you really want to undo the result of a pull operation, use unpull! Unrecord is primarily intended for when you record a patch, realize it needs just one more change, but would rather not have a separate patch for just that one change.

WARNING: Unrecord should not be run when there is a possibility that another user may be pulling from the same repo. Attempting to do so may cause repository corruption.

--from-match, --from-patch, --from-tag, --last

Usually you only want to unrecord the latest changes, and almost never would you want to unrecord changes before a tag (you would have to unrecorded the tag as well to do that). Therefor, and for efficiency, darcs only prompts you for the latest patches, after some optimal tag.

If you do want to unrecord more patches in one go, there are the `--from` and `--last` options to set the earliest patch selectable to unrecord.

--matches, --patches, --tags

With these options you can specify what patch or patches to be prompted for by unrecord. This is especially useful when you want to unrecord patches with dependencies, since all the dependent patches (but no others) will be included in the choices.

These options can be slow if the list of patches to match with is long, which can happen if `--from` or `--last` is used. The latter options can of course be used to shorten the list too, if it is long by default.

## darcs unpull

`Usage: darcs unpull [OPTION]...`

Options:

`--from-match PATTERN`

select changes starting with a patch matching PATTERN

`--from-patch REGEXP`

select changes starting with a patch matching REGEXP

`--from-tag REGEXP`

select changes starting with a tag matching REGEXP

`--last NUMBER`

select the last NUMBER patches

`--matches PATTERN`

select patches matching PATTERN

`-p`

`--patches REGEXP`

select patches matching REGEXP

`-t`

`--tags REGEXP`

select tags matching REGEXP

`-v`

`--verbose`

give verbose output

`--standard-verbosity`

don't give verbose output

`--compress`

create compressed patches

`--dont-compress`

don't create compressed patches

`--ignore-times`

don't trust the file modification times

`--repodir DIRECTORY`

specify the repository directory in which to run

Unpull completely removes recorded patches from your local repository. The changes will be undone in your working copy and the patches will not be shown in your changes list anymore. Beware that if the patches are not still present in another repo you will lose precious code by unpulling!

Unlike unrecord, unpull does not just delete the patch from the repository, it actually applies an inverse patch to the repository. This makes unpull a particularly dangerous command, as it not only deletes the patch from the repo, but also removes the changes from the working directory. It is equivalent to an unrecord followed by a revert, except that revert can be unreverted.

WARNING: Unpull should not be run when there is a possibility that another user may be pulling from the same repo. Attempting to do so may cause repository corruption.

Contrary to what its name suggests, there is nothing in unpull that requires that the ``unpulled'' patch originate from a different repository. The name was chosen simply to suggest a situation in which it is ``safe'' to used unpull. If the patch was originally from another repo, then unpulling is safe, because you can always pull the patch again if you decide you want it after all. If you unpull a locally recorded patch, all record of that change is lost, which is what makes this a ``dangerous'' command, and thus deserving of an obscure name which is more suggestive of when it is safe to use than precisely what it does.

--from-match, --from-patch, --from-tag, --last

For efficiency, darcs only prompts you for the latest patches, after some optimal tag. If you do want to unpull more patches in one go, there are the `--from` and `--last` options to set the earliest patch selectable to unpull.

--matches, --patches, --tags

With these options you can specify what patch or patches to be prompted for by unpull. This is especially useful when you want to unpull patches with dependencies, since all the dependent patches (but no others) will be included in the choices.

In the case of tags, what you are unpulling is the tag itself, not any other patches.

These options can be slow if the list of patches to match with is long, which can happen if `--from` or `--last` is used. The latter options can of course be used to shorten the list too, if it is long by default.

## darcs obliterate

`Usage: darcs obliterate [OPTION]...`

Options:

`--from-match PATTERN`

select changes starting with a patch matching PATTERN

`--from-patch REGEXP`

select changes starting with a patch matching REGEXP

`--from-tag REGEXP`

select changes starting with a tag matching REGEXP

`--last NUMBER`

select the last NUMBER patches

`--matches PATTERN`

select patches matching PATTERN

`-p`

`--patches REGEXP`

select patches matching REGEXP

`-t`

`--tags REGEXP`

select tags matching REGEXP

`-v`

`--verbose`

give verbose output

`--standard-verbosity`

don't give verbose output

`--compress`

create compressed patches

`--dont-compress`

don't create compressed patches

`--ignore-times`

don't trust the file modification times

`--repodir DIRECTORY`

specify the repository directory in which to run

Obliterate completely removes recorded patches from your local repository. The changes will be undone in your working copy and the patches will not be shown in your changes list anymore. Beware that you can lose precious code by obliterateing!

Obliterate deletes a patch from the repository and removes those changes from the working directory. It is therefore a very dangerous command. When there are no local changes, obliterate is equivalent to an unrecord followed by a revert, except that revert can be unreverted. In the case of tags, obliterate removes the tag itself, not any other patches.

Note that obliterate is currently an alias for unpull.

WARNING: Obliterate should not be run when there is a possibility that another user may be pulling from the same repo. Attempting to do so may cause repository corruption.

--from-match, --from-patch, --from-tag, --last

For efficiency, darcs only prompts you for the latest patches, after some optimal tag. If you do want to unpull more patches in one go, there are the `--from` and `--last` options to set the earliest patch selectable to unpull.

--matches, --patches, --tags

With these options you can specify what patch or patches to be prompted for by unpull. This is especially useful when you want to unpull patches with dependencies, since all the dependent patches (but no others) will be included in the choices.

## darcs revert

`Usage: darcs revert [OPTION]... [FILE or DIRECTORY]...`

Options:

`-v`

`--verbose`

give verbose output

`--standard-verbosity`

don't give verbose output

`--ignore-times`

don't trust the file modification times

`-a`

`--all`

answer yes to all patches

`--interactive`

prompt user interactively

`--repodir DIRECTORY`

specify the repository directory in which to run

Revert is used to undo changes made to the working copy which have not yet been recorded. You will be prompted for which changes you wish to undo. The last revert can be undone safely using the unrevert command if the working copy was not modified in the meantime. The actions of a revert may be reversed using the unrevert command (see subsection ). However, if you've made changes since the revert your mileage may vary, so please be careful.

You can give revert optional arguments indicating files or directories. If you do so it will only prompt you to revert changes in those files or in files in those directories.

##
darcs unrevert

`Usage: darcs unrevert [OPTION]...`

Options:

`-v`

`--verbose`

give verbose output

`--standard-verbosity`

don't give verbose output

`--ignore-times`

don't trust the file modification times

`-a`

`--all`

answer yes to all patches

`--interactive`

prompt user interactively

`--repodir DIRECTORY`

specify the repository directory in which to run

Unrevert is used to undo the results of a revert command. It is only guaranteed to work properly if you haven't made any changes since the revert was performed.

The command makes a best effort to merge the unreversion with any changes you have since made. In fact, unrevert should even work if you've recorded changes since reverting.

# Advanced examination of the repository

## darcs diff

`Usage: darcs diff [OPTION]... [FILE or DIRECTORY]...`

Options:

`--to-match PATTERN`

select changes up to a patch matching PATTERN

`--to-patch REGEXP`

select changes up to a patch matching REGEXP

`--to-tag REGEXP`

select changes up to a tag matching REGEXP

`--from-match PATTERN`

select changes starting with a patch matching PATTERN

`--from-patch REGEXP`

select changes starting with a patch matching REGEXP

`--from-tag REGEXP`

select changes starting with a tag matching REGEXP

`--match PATTERN`

select a single patch matching PATTERN

`-p`

`--patch REGEXP`

select a single patch matching REGEXP

`--last NUMBER`

select the last NUMBER patches

`--diff-opts OPTIONS`

options to pass to diff

`-u`

`--unified`

pass -u option to diff

`--repodir DIRECTORY`

specify the repository directory in which to run

Diff can be used to create a diff between two versions which are in your repository. Specifying just -from-patch will get you a diff against your working copy. If you give diff no version arguments, it gives you the same information as whatsnew except that the patch is formatted as the output of a diff command

--diff-opts

Diff calls an external ``diff'' command to do the actual work, and passes any unrecognized flags to this diff command. Thus you can call

    % darcs diff -t 0.9.8 -t 0.9.10 -- -u

to get a diff in the unified format. Actually, thanks to the wonders of getopt you need the ```--`'' shown above before any arguments to diff. You can also specify additional arguments to diff using the `--diff-opts` flag. The above command would look like this:

    % darcs diff --diff-opts -u -t 0.9.8 -t 0.9.10

This may not seem like an improvement, but it really pays off when you want to always give diff the same options. You can do this by adding

    % diff diff-opts -udp

to your `_darcs/prefs/defaults` file.

If you want to view only the differences to one or more files, you can do so with a command such as

    % darcs diff foo.c bar.c baz/

FIXME: I should allow the user to specify the external diff command. Currently it is hardwired to "diff".

##
darcs annotate

`Usage: darcs annotate [OPTION]... [FILE or DIRECTORY]...`

Options:

`-v`

`--verbose`

give verbose output

`--standard-verbosity`

don't give verbose output

`-s`

`--summary`

summarize changes

`--no-summary`

don't summarize changes

`-u`

`--unified`

output patch in a darcs-specific format similar to diff -u

`--human-readable`

give human-readable output

`--xml-output`

generate XML formatted output

`--match PATTERN`

select patch matching PATTERN

`-p`

`--patch REGEXP`

select patch matching REGEXP

`-t`

`--tag REGEXP`

select tag matching REGEXP

`--creator-hash HASH`

specify hash of creator patch (see docs)

`--repodir DIRECTORY`

specify the repository directory in which to run

Display which patch last modified something. Annotate displays which patches created or last modified a directory file or line. It can also display the contents of a particular patch in darcs format.

--human-readable, --summary, --unified, --xml--output

When called with just a patch name, annotate outputs the patch in darcs format, which is the same as `--human-readable`.

`--xml-output` is the alternative to `--human-readable`.

`--summary` can be used with either the `--xml-output` or the `--human-readable` options to alter the results. It is documented fully in the 'common options' portion of the manual.

Giving the `--unified` flag implies `--human-readable`, and causes the output to remain in a darcs-specific format that is similar to that produced by `diff --unified`.

If a directory name is given, annotate will output details of the last modifying patch for each file in the directory and the directory itself. The details look like this:

     # Created by [bounce handling patch
     # mark**20040526202216]  as ./test/m7/bounce_handling.pl
        bounce_handling.pl

If a patch name and a directory are given, these details are given for the time after that patch was applied will be output. If a directory and a tag name are given, the details of the patches involved in the specified tagged version will be output.

If a file name is given, the last modifying patch details of that file will be output, along with markup indicating patch details when each line was last (and perhaps next) modified.

--creator-hash HASH

The `--creator-hash` option should only be used in combination with a file or directory to be annotated. In this case, the name of that file or directory is interpreted to be its name at the time it was created, and the hash given along with `--creator-hash` indicates the patch that created the file or directory. This allows you to (relatively) easily examine a file even if it has been renamed multiple times.

##
darcs query manifest

`Usage: darcs query manifest [OPTION]...`

Options:

`--files`

include files in output [DEFAULT]

`--no-files`

do not include files in output

`--directories`

include directories in output

`--no-directories`

do not include directories in output [DEFAULT]

`--pending`

reflect pending patches in output [DEFAULT]

`--no-pending`

only included recorded patches in output

`-0`

`--null`

separate file names by NUL characters

`--repodir DIRECTORY`

specify the repository directory in which to run

The manifest command lists the version-controlled files in the working copy.

By default (and if the `--pending` option is specified), the effect of pending patches on the repository is taken into account. In other words, if you add a file using `darcs add`, it immediately appears in the output of `query manifest`, even if it is not yet recorded. If you specify the `--no-pending` option, `query manifest` will only list recorded files (and directories).

The `--files` and `--directories` options control whether files and directories are included in the output. The `--no-files` and `--no-directories` options have the reverse effect. The default is to include files, but not directories.

If you specify the `--null` option, the file names are written to standard output in unescaped form, and separated by ASCII NUL bytes. This format is suitable for further automatic processing (for example, using `xargs -0`).

# Rarely needed and obscure commands

## darcs resolve

`Usage: darcs resolve [OPTION]...`

Options:

`-v`

`--verbose`

give verbose output

`--standard-verbosity`

don't give verbose output

`--ignore-times`

don't trust the file modification times

`--repodir DIRECTORY`

specify the repository directory in which to run

Resolve is used to mark and resolve any conflicts that may exist in a repository. Note that this trashes any unrecorded changes in the working copy.

## darcs dist

`Usage: darcs dist [OPTION]...`

Options:

`-d`

`--dist-name DISTNAME`

name of version

`-v`

`--verbose`

give verbose output

`--standard-verbosity`

don't give verbose output

Create a distribution tarball.

Dist is a handy tool for implementing a "make dist" target in your makefile. It creates a tarball of the recorded edition of your tree. Basically, you will typically use it in a makefile rule such as

    dist:
        darcs dist --dist-name darcs-`./darcs --version`

`darcs dist` then simply creates a clean copy of the source tree, which it then tars and gzips. If you use programs such as autoconf or automake, you really should run them on the clean tree before tarring it up and distributing it. You can do this using the pref value ``predist'', which is a shell command that is run prior to tarring up the distribution:

    % darcs setpref predist "autoconf && automake"

## darcs trackdown

`Usage: darcs trackdown [OPTION]... [[INITIALIZATION] COMMAND]`

Options:

`-v`

`--verbose`

give verbose output

`--standard-verbosity`

don't give verbose output

Trackdown tries to find the most recent version in the repository which passes a test. Given no arguments, it uses the default repository test. Given one argument, it treats it as a test command. Given two arguments, the first is an initialization command with is run only once, and the second is the test command.

Trackdown is helpful for locating when something was broken. It creates a temporary directory with the latest repo content in it and cd to it. First, and only once, it runs the initialization command if any, for example

    'autoconf; ./configure >/dev/null'

Then it runs the test command, for example

    'make && cd tests && sh /tmp/test.sh'

While the test command exits with an error return code, darcs ``unapplies'' one patch from the version controlled files to retrieve an earlier version, and repeats the test command. If the test command finally succeeds, the name of the hunted down patch is found in the output before the last test run.

FIXME: It is still rather primitive. Currently it just goes back over the history in reverse order trying each version. I'd like for it to explore different patch combinations, to try to find the minimum number of patches that you would need to unpull in order to make the test succeed.

FIXME: I also would like to add an interface by which you can tell it which patches it should consider not including. Without such a feature, the following command:

    % darcs trackdown 'make && false'

would result in compiling every version in the repository-which is a rather tedious prospect.

### Example usage

If you want to find the last version of darcs that had a FIXME note in the file Record.lhs, you could run

    % darcs trackdown 'grep FIXME Record.lhs'

To find the latest version that compiles, you can run

    % darcs trackdown 'autoconf' './configure && make'

Trackdown can also be used to see how other features of the code changed with time. For example

    % darcs trackdown 'autoconf; ./configure' \
       "make darcs &> /dev/null && cd ~/darcs && time darcs check && false"

would let you see how long `darcs check' takes to run on each previous version of darcs that will actually compile. The ```&& false`'' ensures that trackdown keeps going.

## darcs repair

`Usage: darcs repair [OPTION]...`

Options:

`-v`

`--verbose`

give verbose output

`-q`

`--quiet`

suppress informational output

`--standard-verbosity`

neither verbose nor quiet output

Repair attempts to fix corruption that may have entered your repository.

Repair currently will only repair damage to the pristine tree. Fortunately this is just the sort of corruption that is most likely to happen.